#ifndef GRID_H
#define GRID_H
#include"case.h"
#include<iostream>
using namespace std;
class grid
{   private :
    Case grille[9][9];//la grille de sudoku
    int choix[9][9];//stocke le nombre de choix pour chaque case
    bool choix_init_flag;//drapeau definissant si la grille choix a ete initialisee
    bool choix_set_flag;//drapeau indiquant si la grille "choix" a ete mise a jour depuis la derniere modification de la grille "grille"
    int lastmodif;//position de la derniere case modifiee
    
    public :
    grid();
    ~grid();
    Case *Grille(int ligne,int colonne);
    void setflag(bool b,int ligne,int colonne);
    void setvaleur(int valeur,int ligne,int colonne);
    bool in_square(int valeur,int ligne,int colonne) const;
    bool in_line(int valeur,int ligne) const;
    bool in_colonne(int valeur,int colonne) const;
    bool libre(int valeur,int ligne,int colonne) const;
    int choice(int ligne,int colonne) const;
    int leastchoice();
    void setchoice();
    void leastchoiceinit();
    void show(ostream &o=cout) const;
    
};



#endif

